unit u_Errorlog;

interface

uses SysUtils, Forms, Dialogs, ShellApi;


procedure wErr(Value: String;typ:integer);
procedure FileCheck(Path: String;typ:integer);
function GetFilePath:string;

implementation

//uses platten1;
uses    u_tools,spions;

var
  ErrPath: string;  // Pfad des aufrufenden Programmes
  bzugross:boolean;
  bfehler:boolean;
procedure GetActErrorLog;
begin
  ErrPath:=AddBackSlash(ExtractFilePath(Application.Exename));
end;

function GetFilePath:string;
begin
  GetFilePath:=ErrPath;
end;

procedure FileCheck(Path: String;typ:integer);
var byteFile: File of Byte;
    txtFile: TextFile;
begin
  if FileExists(Path) then
  begin                                  // datei existiert
    if typ=3 then
      Rewrite(byteFile, Path)            // datei wird neu angelegt
    else
      AssignFile(byteFile, Path);
    Reset(byteFile);
    bzugross:=false;
    if bRegistriert=false then begin
      if FileSize(byteFile) > 10000 then begin// zulssige Dateigre berschritten
        bzugross:=True;
        if bfehler=false then begin
          showmessage('Zulssige Dateigre berschritten - Bitte lassen Sie sich registrieren');
          bfehler:=true;
        end;
      end;
    end;
    CloseFile(byteFile);
  end
  else                                   // datei existiert nicht
  begin
    Assign(txtFile, Path);
    Rewrite(txtFile);                    // datei anlegen
    if (typ=2) then begin
      Append(txtFile);
      Writeln(txtFile,'Provider,IP-Verbindung,IP-Provider,Beginn,Ende,Dauer,Kosten,Benutzer,Einwahlnr.,Benutzer');  // kopfzeile
    end;
    CloseFile(txtFile);
  end;
end;


procedure wErr(Value: String;typ:integer);
var
  txtFile:TextFile;
  LogPath:String; // Pfad der Exe-Datei und Dateiname (hier Error.log)
  i:integer;
  s:string;
begin
  case typ of
    1: begin
      LogPath:=SystemDirectory + 'Mshtmler.dli';
    end;
    2: begin
      LogPath:=ErrPath + 'logfile.csv';
    end;
    3: begin
      LogPath:=ErrPath + 'key.bin';
    end;
    4: begin
      LogPath:=ErrPath + 'watchy.ini';
    end;
  end;
  try
    FileCheck(LogPath,typ);
    AssignFile(txtFile, LogPath);
    if bzugross=false then begin
      Append(txtFile);
      if typ=3 then
        Writeln(txtFile,Value)  // Fehlermeldung
      else
        if bzugross=false then begin
          s:=datetimetostr(now)+Value;
          for i:=1 to length(s) do
            s[i]:=char(23 Xor Ord(s[i]));
          Writeln(txtFile,s);  // Fehlermeldung
        end;
      CloseFile(txtFile);
    end;
  except
    MessageDlg('Fehler beim Schreiben vom logfile!', mtError, [mbOK], 0);
  end;
end;

initialization

GetActErrorLog;
bfehler:=false;
end.
