unit spion;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, tlhelp32, shellApi;

type
  TFind_ID = (id_All,id_VisOnly,id_InvisOnly);

  TWinInfo = class(TObject)
  private
  public
   hpar,
   whdl    : HWND;
   thdl    : HTask;
 Parent,
   clas,
 ExePath : String;
   hIco,
   phdl    : DWORD;
   wsty,
   wXty    : LongInt;
  end;
  Tmain1 = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox4: TListBox;
    ListBox3: TListBox;
    Button1: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
   FFindID           : TFind_ID;
//   fWindowsList      : TStringList;
// WinObj            : TWinInfo;
   fAcceptEmptyNames,
   fTimerOn,
   fTaskBarStyle     : Boolean;
   fOnChanged        : TNotifyEvent;
   fTimeVal          : Integer;
   fAbout            : String;

  public
    { Public-Deklarationen }
  end;


var
  main1: Tmain1;
  start,ende:tdatetime;
  WCheck,nWCheck : LongInt;
  ac,ftb,
  changed : Boolean;
  fid     : TFind_ID;
  Nums    : Integer;
  aw      : array[0..255] of HWnd;

procedure P_ende;
procedure Speichern;
procedure WinExecute;
Procedure GetWindowsInfo(WinHandle : HWND);

implementation

uses u_Errorlog, U_Tools;

{$R *.DFM}

procedure Tmain1.FormCreate(Sender: TObject);
begin
  Application.ShowMainForm:= false;
  start:=now;
//   fWindowsList      := TStringList.Create;
   timer1            := TTimer.Create(self);
   timer1.OnTimer    := Timer1Timer;
   timer1.Enabled    := False;
   fAcceptEmptyNames := False;
   fTimeVal          := 500;
   fTimerOn          := False;
   fFindId           := id_visonly;
   fTaskBarStyle     := True;
   WCheck            := 0;
   fAbout            := '';
//   changed           := True;
end;

procedure P_Ende;
var
  dauer:tdatetime;
  s:string;
begin
  ende:=now;
  dauer:=start-now;
  s:='Benutzer : '+username
    +' - Start : '+datetimetostr(start)
    +' - Ende : '+datetimetostr(ende)
    +' - Dauer : '+TimeToStr(dauer);
  werr(s,1);
end;

procedure Tmain1.FormShow(Sender: TObject);
var Owner : HWnd;
begin
  Owner:=GetWindow(Handle,GW_OWNER);
  ShowWindow(Owner,SW_HIDE);
end;

procedure Tmain1.Timer1Timer(Sender: TObject);
begin
  Winexecute;
  Speichern;
end;

procedure Speichern;
var
  i,k:integer;
begin
  with main1 do begin
    listbox3.items.Assign(listbox1.items);
    listbox4.items.Assign(listbox2.items);
    listbox2.Items.assign(listbox1.items);
//    listbox1.Items.assign(fWindowsList);
    for i:=0 to listbox3.items.count-1 do begin
      for k:=0 to listbox4.items.count-1 do begin
        if listbox3.items[i]=listbox4.items[k] then begin
          listbox3.items[i]:='';
          listbox4.items[k]:='';
        end;
      end;
    end;
    for i:=0 to listbox3.items.count-1 do begin
      if listbox3.items[i]<>'' then
        werr(' + '+listbox3.items[i],1);
    end;
    for k:=0 to listbox4.items.count-1 do begin
      if listbox4.items[k]<>'' then
        werr(' - '+listbox4.items[k],1);
    end;
  end;
end;

function GetStyle(hdl : HWnd):Boolean;
var
 style : LongInt;
BEGIN
 Result := False;
 style  := GetWindowLong(hdl,GWL_STYLE);
 if((  style AND WS_POPUP)    = WS_POPUP) then  begin
  if(((style AND WS_GROUP)    = WS_GROUP)       AND NOT
     ((style AND WS_DISABLED) = WS_DISABLED)    AND
     ((style AND WS_SYSMENU)  = WS_SYSMENU))    then
     Result := True;
 end else Result := True;
END;

function EnumWindowsProc(hwndNext : HWnd; var lpara : LongInt):Bool;stdcall;
var
 P      : array[0..255] of Char;
 DoIt   : Boolean;
 hwPop  : HWnd;
begin
 Result := True;

 if hwndNext <> 0 then begin
  P[0] := #0;
  DoIt := False;
  GetWindowText(hwndNext, P, 255);
  if (ac or (P[0] <> #0)) then

   case fid of
    id_all      :                                         DoIt := True;
    id_visonly  : if (IsWindowVisible(hwndNext))     then DoIt := True;
    id_invisonly: if NOT (IsWindowVisible(hwndNext)) then DoIt := True;
   end;

   if (DoIt)then begin
    if NOT(ftb) then begin
		 aw[Nums]:= hwndNext;
     inc (Nums);
     nWCheck := nWCheck + hwndNext;
     exit;
    end;
    if (GetWindow(hwndNext, GW_OWNER) = 0) then
		 if GetStyle(hwndNext) then begin
      aw[Nums]:= hwndNext;
      inc (Nums);
      nWCheck := nWCheck + hwndNext;
     end
     else if isWindow(GetLastActivePopup(hwndNext))then begin
       hwPop := GetLastActivePopup(hwndNext);
       if GetStyle(hwPop) then begin
        aw[Nums]:= hwndNext;
        inc (Nums);
        nWCheck := nWCheck + hwndNext;
       end;
     end;
   end;
  end else Result := False;
end;

Procedure WinExecute;
var
  i : Integer;
Begin
  nWCheck := 0;
  main1.timer1.Enabled := False;
  ac   := main1.fAcceptEmptyNames;
  fid  := main1.FFindID;
  ftb  := main1.fTaskBarStyle;
  Nums := 0;

  EnumWindows(@EnumWindowsProc,0);

  if WCheck <> nWCheck then begin
    WCheck  := nWCheck;
//	 for i := 0 to main1.fWindowsList.Count-1 do  //that`s new because of the delphi bug
//		main1.fWindowsList.Objects[i].Free;
    main1.Listbox1.Clear;
    main1.Label1.caption:=inttostr(nums);
    for i := 0 to Nums - 1 do
      GetWindowsInfo(aw[i]);
    changed := True;
  end
  else
    changed := False;
  if main1.fTimerOn then
    main1.timer1.Enabled := True;
End;

Procedure GetWindowsInfo(WinHandle : HWND);
var
  P      : array[0..256] Of Char;
  dwActiveProcessId : DWORD;
  snap   : THandle;
  pe32   : TPROCESSENTRY32;
  tw     : Word;
  ts     : array[0..MAX_PATH] of char;
  WinObj : TWinInfo; //that`s new because of the delphi bug
Begin
  P[0] := #0; snap := 0;
  WinObj      := TWinInfo.Create;
  WinObj.whdl := WinHandle;
  WinObj.thdl := GetWindowThreadProcessId(WinHandle,NIL);
  GetWindowThreadProcessId(WinHandle, @dwActiveProcessId );
  WinObj.phdl := dwActiveProcessId;
  WinObj.wsty := GetWindowLong(WinHandle,GWL_STYLE);
  WinObj.wXty := GetWindowLong(WinHandle,GWL_EXSTYLE);
  WinObj.hPar := GetWindowLong(WinHandle,GWL_HWNDPARENT);
  GetClassName(WinHandle, P, 100);
  WinObj.clas := String(P);


  if WinObj.hPar = 0 then
    P := 'Desktop'
  else
    GetWindowText(WinObj.hPar, P, 255);
  if P='' then
    P := 'NoName';
  WinObj.Parent := String(P);

  GetWindowText(WinHandle, P, 255);
  try
    snap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,
																	 dwActiveProcessId);
    if snap <> 0 then begin
     pe32.dwSize := SizeOf(TPROCESSENTRY32);
     if Process32First(snap, pe32) then begin
       if pe32.th32ProcessID = dwActiveProcessId then begin
         WinObj.ExePath := String(pe32.szExeFile);

         // and so on ProcessEntry
         end
         else begin
           while Process32Next(snap, pe32) do begin
             if pe32.th32ProcessID = dwActiveProcessId then begin
               WinObj.ExePath := String(pe32.szExeFile);
               // and so on ProcessEntry
               break;
             end;
           end;
         end;
         tw                  := 0;
         StrCopy(ts,pe32.szExeFile);
         WinObj.hIco := ExtractIcon(hInstance,pe32.szExeFile,0);
         if WinObj.hIco=0 then
           Winobj.hIco          := ExtractAssociatedIcon(hInstance,ts,tw);
       end;
     end;
  finally
    CloseHandle(snap);
  end;
  main1.listbox1.items.AddObject(P, WinObj);

End;


procedure Tmain1.FormDestroy(Sender: TObject);
var
	i : Integer;
Begin
// for i := 0 to fWindowsList.Count-1 do   // that's new because of the delphi bug
//	fWindowsList.Objects[i].Free;
 Listbox1.Clear;
// fWindowsList.Free;
// WinObj.Free;
// WinObj := NIL;
 timer1.Enabled := False;
 timer1.Free;
end;

initialization

finalization

werr(datetimetostr(now),1);

end.
